package net.krakatoaapi.command;

import de.dytanic.cloudnet.driver.CloudNetDriver;
import de.dytanic.cloudnet.driver.permission.IPermissionUser;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import net.krakatoaapi.KrakatoaAPI;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

public class KrakataoCommand implements CommandExecutor {

  @Override
  public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command,
      @NotNull String label, @NotNull String[] args) {

    if (!(sender instanceof Player)) {
      return false;
    }

    Player player = ((Player) sender).getPlayer();

    if (player != null) {
      IPermissionUser permissionUser = CloudNetDriver.getInstance().getPermissionManagement()
          .getUser(player.getUniqueId());

      if (permissionUser != null && permissionUser.hasPermission("*").asBoolean()) {
        DateTimeFormatter dateTimeFormatter = DateTimeFormatter.ofPattern("dd/MM/yyyy HH:mm:ss");
        LocalDate localDate = LocalDate.now();

        player.sendMessage(" ");
        player.sendMessage("§7DateTime: §e" + dateTimeFormatter.format(localDate));
        player.sendMessage("§7ServerName: §a" + CloudNetDriver.getInstance().getComponentName());
        player.sendMessage(
            "§7Dest: §a" + KrakatoaAPI.getInstance().getKraSocketClient().getSocketClient()
                .getDest());
        player.sendMessage(
            "§7Messages in SendQueue: §a" + KrakatoaAPI.getInstance().getKraSocketClientProtocol()
                .getSendQueueMessages().size());
        player.sendMessage(
            "§7Messages in ReceivedQueue: §a" + KrakatoaAPI.getInstance()
                .getKraSocketClientProtocol()
                .getReceivedQueueMessages().size());
      }
    }
    return true;
  }
}
